import { PathPredicate } from './iterateSources';
import { BabelPlugin, RawBabelPlugin } from './TransformRunner';
export declare const DEFAULT_EXTENSIONS: Set<string>;
export declare type ParseOptionsResult = Options | Error;
export declare class Plugin {
    readonly rawPlugin: RawBabelPlugin;
    readonly inferredName: string;
    readonly source: string | undefined;
    readonly resolvedPath: string | undefined;
    readonly declaredName?: string;
    constructor(rawPlugin: RawBabelPlugin, inferredName: string, source?: string | undefined, resolvedPath?: string | undefined);
}
export default class Options {
    readonly sourcePaths: Array<string>;
    readonly localPlugins: Array<string>;
    readonly remotePlugins: Array<string>;
    readonly pluginOptions: Map<string, object>;
    readonly extensions: Set<string>;
    readonly requires: Array<string>;
    readonly transpilePlugins: boolean;
    readonly findBabelConfig: boolean;
    readonly ignore: PathPredicate;
    readonly stdio: boolean;
    readonly help: boolean;
    readonly dry: boolean;
    constructor(sourcePaths: Array<string>, localPlugins: Array<string>, remotePlugins: Array<string>, pluginOptions: Map<string, object>, extensions: Set<string>, requires: Array<string>, transpilePlugins: boolean, findBabelConfig: boolean, ignore: PathPredicate, stdio: boolean, help: boolean, dry: boolean);
    private pluginLoader;
    private remotePluginLoader;
    private _pluginCache?;
    getPlugins(): Promise<Array<Plugin>>;
    loadRequires(): void;
    loadBabelTranspile(): void;
    unloadBabelTranspile(): void;
    getPlugin(name: string): Promise<Plugin | null>;
    getBabelPlugins(): Promise<Array<BabelPlugin>>;
    getBabelPlugin(name: string): Promise<BabelPlugin | null>;
    static parse(args: Array<string>): ParseOptionsResult;
}
