import * as Babel from '@babel/core';
import { GeneratorOptions } from '@babel/generator';
import { Visitor } from '@babel/traverse';
export declare class Source {
    readonly path: string;
    readonly content: string;
    constructor(path: string, content: string);
}
export declare class SourceTransformResult {
    readonly source: Source;
    readonly output: string | null;
    readonly error: Error | null;
    constructor(source: Source, output: string | null, error: Error | null);
}
export declare type ParseOptions = object;
export declare type AST = object;
export declare type RawBabelPlugin = (babel: typeof Babel) => {
    name?: string;
    visitor?: Visitor;
    parserOverride?: (code: string, options: ParseOptions, parse: (code: string, options: ParseOptions) => AST) => AST;
    generatorOverride?: (ast: AST, options: GeneratorOptions, code: string, generate: (ast: AST, options: GeneratorOptions) => string) => string;
};
export declare type RawBabelPluginWithOptions = [RawBabelPlugin, object];
export declare type BabelPlugin = RawBabelPlugin | RawBabelPluginWithOptions;
export default class TransformRunner {
    readonly sources: IterableIterator<Source> | Array<Source>;
    readonly plugins: Array<BabelPlugin>;
    constructor(sources: IterableIterator<Source> | Array<Source>, plugins: Array<BabelPlugin>);
    run(): IterableIterator<SourceTransformResult>;
    private transformSource(source);
}
