"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@babel/core");
class Source {
    constructor(path, content) {
        this.path = path;
        this.content = content;
    }
}
exports.Source = Source;
class SourceTransformResult {
    constructor(source, output, error) {
        this.source = source;
        this.output = output;
        this.error = error;
    }
}
exports.SourceTransformResult = SourceTransformResult;
class TransformRunner {
    constructor(sources, plugins) {
        this.sources = sources;
        this.plugins = plugins;
    }
    *run() {
        for (let source of this.sources) {
            let transformed;
            try {
                let output = this.transformSource(source);
                transformed = new SourceTransformResult(source, output, null);
            }
            catch (err) {
                transformed = new SourceTransformResult(source, null, err);
            }
            yield transformed;
        }
    }
    transformSource(source) {
        return core_1.transform(source.content, {
            filename: source.path,
            babelrc: false,
            plugins: this.plugins
        }).code;
    }
}
exports.default = TransformRunner;
//# sourceMappingURL=TransformRunner.js.map