/// <reference types="node" />
import { readdirSync, readFileSync, statSync, Stats } from 'fs';
import { Source } from './TransformRunner';
export declare type PathPredicate = (path: string, basename: string, root: string, stat: Stats) => boolean;
/**
 * Builds an iterator that loops through all the files in the given paths,
 * matching a whitelist of extensions and not matched by the ignore predicate.
 */
export default function iterateSources(paths: Array<string>, extensions: Set<string>, ignore: PathPredicate, statSyncImpl?: typeof statSync, readdirSyncImpl?: typeof readdirSync, readFileSyncImpl?: typeof readFileSync): IterableIterator<Source>;
